require 'claide'

module XZGit
    require 'mrbin/config'
    class Command < CLAide::Command
        self.abstract_command = true
        self.command = 'xzmr'
        self.version = VERSION
        self.description = 'xz merge request tool'
        self.plugin_prefixes = %w(claide)


        def self.run(argv)
            read_private_token()
            verify_git_repo()
            read_remote_project()
            super(argv)
        end

        def initialize(argv)
            super
        end

        def self.read_private_token()
            if !ENV['GITAPITOKEN']
                puts "not found gitlab private token"
                exit(1)
            end
            if ENV['GITAPITOKEN'].empty?
                puts "gitlab private token is empty"
                exit(1)
            end
            XZGit.settoken(ENV['GITAPITOKEN'])
        end

        def self.read_remote_project()
            remote = `git config --get remote.origin.url`
            projecturl = remote.split(':')[1].split('.')[0]
            projecturl = projecturl.gsub("/","%2F")
            XZGit.setproject(projecturl)
            projecturl
        end

        def self.verify_git_repo()
            currentpath = Dir.pwd
            gitpath = "#{currentpath}/.git"
            if !File.directory?(gitpath)
                puts "can not found .git ,please check your path"
                exit(1)
            end
        end
    end
    require 'mrbin/xzcommand/xzmr'
    require 'mrbin/xzcommand/xzintegratecommit'
    require 'mrbin/xzcommand/xzdevgit'
    require 'mrbin/xzcommand/xzupversion'
end