require 'set'
require 'find'
module XZGit
    class XZDevGit < XZGit::Command
        self.summary = 'DevPods git command'

        def self.options 
            [
                ['--exclude','exclude pod name']
            ].concat(super)
        end

        def initialize(argv)
            @exclude = argv.option('exclude','').split(',')
            @gitcommands = argv.arguments
            super
        end

        def validate!
            root_path = Dir.pwd()
            dev_path = "#{root_path}/DevPods"
            if File.directory?(dev_path) && !Dir.empty?(dev_path)
                puts "devpods path --> #{dev_path}"
            else
                puts "DevPods does not exist or DevPods is empty"
                exit(1) 
            end
        end

        def run
            pods = excutepods()
            excutecommand(pods)
        end

        private
        def excutepods
            root_path = Dir.pwd()
		    dev_path = "#{root_path}/DevPods"
		    pods = Set.new
            Find.find(dev_path) do |file|
                filename = File.basename(file)
                if filename.end_with?('.podspec')
                    filepath = File.dirname(file)
                    pods << filepath
                    podname = filename.split('.')[0]
                    if @exclude.include?(podname)
                        pods.delete(filepath)
                    end
                end
            end
		    pods
        end

        def excutecommand(paths)
            if @gitcommands.count > 0 && paths.count > 0
                paths.each do |path|
                    commandarr = []
				    commandarr << 'git'
				    commandarr << '-C'
                    commandarr << path
                    commandarr << @gitcommands
                    commandstr = commandarr.join(' ')
                    system(commandstr)
                end
            end
        end
    end
end