
module XZGit
    class XZInteCommit < XZGit::Command
        self.summary = 'read all commit pods from podfile'

        def self.options 
            [
                ['--std','target branch name'],
            ].concat(super)
        end

        def initialize(argv)
            @std = argv.flag?('std',false)
            super
        end

        def validate!
            super
            pwdpath = Dir.pwd.strip
            podfilepath = "#{pwdpath}/Podfile"
            if !File.exist?(podfilepath)
                puts "can not found Podfile, please inspect your project path"
                exit(1)
            end
        end

        def run
            pwdpath = Dir.pwd.strip
            podfilepath = "#{pwdpath}/Podfile"
            if @std
                res = `cat #{podfilepath} | grep commit | grep -v MJRefresh | grep -v XZMonitor`
                puts res
            else
                `cat #{podfilepath} | grep commit | grep -v MJRefresh | grep -v XZMonitor > commit.txt`
            end
            
        end

    end
end